<?php
//
// +---------------------------------------------------------------------------+
// | Technorati (TM) Autotage Plugin 0.1.1 for Geeklog - The Ultimate Weblog   |
// +---------------------------------------------------------------------------+
// | functions.inc                                                             |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2002-2006 by the following authors:                         |
// |                                                                           |
// | Author:                                                                   |
// | Constructed with the Universal Plugin                                     |
// | Copyright (C) 2002 by the following authors:                              |
// | Tom Willett                 -    twillett@users.sourceforge.net           |
// | Blaine Lang                 -    langmail@sympatico.ca                    |
// | The Universal Plugin is based on prior work by:                           |
// | Tony Bibbs                  -    tony@tonybibbs.com                       |
// | Copyright (C) 2006 mystral-kk - geeklog AT mystral-kk DOT net             |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

/**
* This is the generic functions.inc for the Universal Plugin Toolkit for Geeklog.
* You need to change all instances of technorati with the name of your plugin.
*/

/**
* Language file Include
*/
$langfile = $_CONF['path'] . 'plugins/technorati/language/' . $_CONF['language'] . '.php';

if (file_exists ($langfile)) 
{
    include_once ($langfile);
}
else 
{
    include_once ($_CONF['path'] . 'plugins/technorati/language/english.php');
}

/*
* Include technorati config file
*/
require_once ($_CONF['path'] . 'plugins/technorati/config.php');

// +---------------------------------------------------------------------------+
// | Geeklog Plugin API Implementations                                        |
// +---------------------------------------------------------------------------+

function plugin_chkVersion_technorati() {
	global $_TECHNORATI;
	
	return $_TECHNORATI['version'];
}

/**
* Returns the items for this plugin that should appear on the main menu
*
* NOTE: this MUST return the url/value pairs in the following format
* $<arrayname>[<label>] = <url>
*
* Universal Plugin:  Uncomment and fill in variables;
* 
* @return    array   Associative array of menu items to be added to menu
*
*/
function plugin_getmenuitems_technorati()
{
    $menuitems = array();
    return $menuitems;

}

/**
* Check to see if this Plugin uses comments
*
* Geeklog is checking to see if this plugin supports comments, tell it no!
* NOTE: to support comments you must use the same date/time based ID for your
* widget.  In other words, to make primary keys for your plugin you should call
* makesid().  Comments are keyed off of that...it is a limitation on how geeklog
* does comments.
*
* @return   boolean true or false
*
*/
function plugin_commentsupport_technorati() 
{
    return false;
}

// This function currently supports the upgrade from 0.1 to 0.1.1

function plugin_upgrade_technorati() {
	global $_CONF, $_TABLES, $_TECHNORATI, $LANG_TECHNORATI;
	
	$result = DB_query("SELECT pi_version FROM {$_TABLES['plugins']} WHERE (pi_name = 'technorati')");
	$A = DB_fetchArray($result);
	$pi_version = $A['pi_version'];
	
// upgrade 0.1 ==> 0.1.1
	/* NONE */

// update plugin info
	$result = DB_query("UPDATE {$_TABLES['plugins']} SET pi_version = \"{$_TECHNORATI['version']}\" WHERE (pi_name = 'technorati')");
	COM_errorLog("Technorati plugin was successfully updated to version {$_TECHNORATI['version']}.");
	
	return $result;
}

/**
* Shows the statistics for the plugin on stats.php.  If
* $showsitestats is 1 then we are to only print the overall stats in the 'site
* statistics' box otherwise we show the detailed stats for the plugin
*
* Universal Plugin:  Modify/uncomment use it
*
* @param    int showsitestate   Flag to let us know which stats to get
* @return   string  returns formatted HTML to insert in stats page
*
*/
function plugin_showstats_technorati($showsitestats) 
{
    $retval = '';
    return $retval;
}

/**
* Removes the datastructures for this plugin from the Geeklog database.
* This routine will get called from the Plugin install program if user select De-Install or if Delete is used in the Plugin Editor.
* The Plugin Installer will also call this routine upon and install error to remove anything it has created.
* The Plugin installer will pass the optional parameter which will then double check that plugin has first been disabled. 
* 
* For this plugin, this routine will also remove the Block definition.
* 
* Returns True if all Plugin related data is removed without error
*
* @param    string   $installCheck     Defult is blank but if set, check if plugin is disabled first
* 
* @return   boolean True if successful false otherwise
*
*/  
function plugin_uninstall_technorati($installCheck = '')
{
    global $_TABLES, $LANG_TECHNORATI;

    // The technoratis need to be changed to the name of your plugin
    //

    $pi_name  = 'technorati';
    // Check and see if plugin is still enabled - if so display warning and exit

	// Ok to proceed and delete plugin

    // Unregister the plugin with Geeklog
    COM_errorLog('Attempting to unregister the technorati plugin from Geeklog',1);
    DB_query("DELETE FROM {$_TABLES['plugins']} WHERE (pi_name = 'technorati')",1);

    // Drop technorati tables

    // Remove Security for this plugin
    COM_errorLog('...success',1);
    return true;
}

// Replace [tech:foo] tags
//
// As of Geeklo-1.4.0, when you use [tech:foo] tag MORE THAN ONE time in a story,
// $autotag['startpos'] cannot be relied upon due to a bug in PLG_replaceTags().

function plugin_autotags_technorati($cmd, $content = '', $autotag = '') {
	global $_TECHNORATI;
	
	if ($cmd == 'tagname') {
		return $_TECHNORATI['tagname'];
	} else if (in_array(strtolower($autotag['tag']), $_TECHNORATI['tagname'])) {
		$tech_tag = $autotag['tagstr'];
		$parm1    = trim($autotag['parm1']);
		$tag_part = '';
		
		if ($parm1 != '') {
			if ($_TECHNORATI['server_type'] == 'Technorati Japan') {
				$tag_part = "<a href='http://technorati.jp/tag/" . rawurlencode($parm1) . "' rel='{$parm1}'>{$parm1}</a>";
			} else if ($_TECHNORATI['server_type'] == 'Technorati') {
				$tag_part = "<a href='http://technorati.com/tag/" . rawurlencode($parm1) . "' rel='{$parm1}'>{$parm1}</a>";
			}
			
			if ($tag_part != '') {
				$content = str_replace($tech_tag, $tag_part, $content);
			}
		}
	}
	
	return $content;
}

?>
